#include <iostream>
#include <cmath>
#include <vector>
#define ll long long
using namespace std;

int main() {
    ll t; cin >> t;
    pair<ll, ll> answers[t];
    for(ll i = 0; i < t; i++) {
        ll a, b, k, m;
        cin >> a >> b >> k >> m;

        ll v = 0;
        vector<pair<ll, ll>> pairs;
        for(ll j = 0; j < sqrt(m); j++) {
            v++;
            if(m % v == 0) { // m = 20, x = 4
                ll h = m / v - 1; // 4
                if(k != v - 1 + h) continue; // -> k = 4 - 1 + 4 = 7
                if (a >= v && b > h) pairs.push_back(make_pair(v - 1, h));
            }
        }
        if(pairs.empty()) answers[i] = make_pair(-1, -1);
        else if(pairs.size() == 1) answers[i] = pairs[0];
        else {
            ll index = 0, smallest = 10000000000;
            for(ll x = 0; x < pairs.size(); x++) {
                if(pairs[x].first < smallest) {
                    smallest = pairs[x].first;
                    index = x;
                }
            }
            answers[i] = pairs[index];
        }
    }
    for(auto answer : answers) {
        if(answer.first == - 1 || answer.second == -1) cout << -1 << endl;
        else cout << answer.first << " " << answer.second << endl;
    }
}